<?php
 /**
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to admins@elayaway.com so we can send you a copy immediately.
 *
 * @category   Community
 * @package    Elayaway_Layaway
 * @copyright  Copyright (c) 2013 eLayaway, Inc.
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * @author     eLayaway, Inc.
 */
    
class elayaway {
        var $code, $title, $description, $enabled;
        
        function elayaway() {
            global $order;
            
            $this->code = 'elayaway';
            $this->title = MODULE_PAYMENT_ELAYAWAY_TEXT_TITLE;
            $this->description = MODULE_PAYMENT_ELAYAWAY_TEXT_DESCRIPTION;
            $this->sort_order = MODULE_PAYMENT_ELAYAWAY_SORT_ORDER;
            $this->enabled = ((MODULE_PAYMENT_ELAYAWAY_STATUS == 'True') ? true : false);
            
            if ((int)MODULE_PAYMENT_ELAYAWAY_ORDER_STATUS > 0) {
                $this->order_status = MODULE_PAYMENT_ELAYAWAY_ORDER_STATUS;
            }
            
            if (is_object($order)) $this->update_status();
        }
        
        function update_status() {
            global $order;
            
            if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_ELAYAWAY_ZONE > 0) ) {
                $check_flag = false;
                $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ELAYAWAY_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
                while ($check = tep_db_fetch_array($check_query)) {
                    if ($check['zone_id'] < 1) {
                        $check_flag = true;
                        break;
                    } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
                        $check_flag = true;
                        break;
                    }
                }
                
                if ($check_flag == false) {
                    $this->enabled = false;
                }
            }
            if ($this->enabled == true) {
                if ($order->content_type == 'virtual') {
                    $this->enabled = false;
                }
            }
        }
        
        function javascript_validation() {
            return false;
        }
    
        function selection() {
            return array('id' => $this->code, 'module' => $this->title);
        }
        
        function pre_confirmation_check() {
            return false;
        }
        
        function confirmation() {
            return false;
        }
        
        function process_button() {
            return false;
        }
        
        function before_process() {
            return false;
        }
    
    function getProductId($product) {
        $product['model'];
        $result = tep_db_query("select products_id from " . TABLE_PRODUCTS . " where products_model='" . $product['model'] . "'");
        $value = tep_db_fetch_array($result);
        return $value['products_id'];
    }
    
    function getProductDescription($product_id) {
        $result = tep_db_query("select products_description from " . TABLE_PRODUCTS_DESCRIPTION . " where products_id='" . $product_id . "'");
        $value = tep_db_fetch_array($result);
        return $value['products_description'];
    }
    
        function after_process() {
            global $insert_id, $cart, $order;
            $items = $order->products;
            $firstItem = $items[0];
            $firstItemId = $this->getProductId($firstItem);
            
            $info = $order->info;
        
            $html = '
                <html>
                    <head>
                        <script src="http://app2.elayaway.com/javascripts/steal/steal.js?calculator,production" type="text/javascript"></script>
                        <style type="text/css">
                        .elayaway_button {
                            position:absolute;
                            left:50%;
                            top:50%;
                            margin: -20px 0px 0px -112px
                        }
                        </style>
                        <script type="text/javascript">
                            $(document).ready(function() {
                                setTimeout(function(){
                                    el_button = $(\'#elayaway_button\');
                                    el_button.trigger(\'click\');
                                }, 150);
                            });
                        </script>
                    </head>
                    <body>
                                            
                    <img id="elayaway_button" class="elayaway_button" src="/images/check_elay_large.jpg" alt="Spread your payments with eLayaway - the smart choice!" data-api="form"/>
                                            
                    <form method="post" action="http://app2.elayaway.com/accept"  id="form">
                        <input type="hidden" name="merchant_id" 			value="'.MODULE_PAYMENT_ELAYAWAY_MERCHANT_ID.'" />
                        <input type="hidden" name="merchant_name" 		value="'.MODULE_PAYMENT_ELAYAWAY_MERCHANT_DISPLAY_NAME.'" />
                        <input type="hidden" name="currency_code"			value="USD" />
                        <input type="hidden" name="return_to" 				value="" />
                        <input type="hidden" name="months" 					value="" />
                        <input type="hidden" name="payment_frequency" 	value="" />
                                            
                        <input type="hidden" name="mode" 					value="bundle" />
                                            
                        <input type="hidden" name="item_name_1" 			value="'.$firstItem['name'].'" />
                        <input type="hidden" name="item_number_1" 			value="'.$firstItemId.'" />
                        <input type="hidden" name="item_description_1" 		value=" " />
            ';
                                            
                    $size = count($items);
                    for($i = 1; $i < $size; $i++)
                    {
                        $tempItemId = $this->getProductId($items[$i]);
                        $html .= '
                            <input type="hidden" name="item_name_'.($i + 1).'"			value="'.$items[$i]['name'].'" />
                            <input type="hidden" name="item_number_'.($i + 1).'"		value="'.$tempItemId.'" />
                            <input type="hidden" name="item_description_'.($i + 1).'"	value=" " />
                        ';
                    }	
                                            
                    $html .= '
                                            
                        <input type="hidden" name="amount_1" 				value="'.$info['subtotal'].'" />
                        <input type="hidden" name="tax_rate_1" 				value="'.$info['tax'].'" />
                        <input type="hidden" name="shipping_1" 				value="'.$info['shipping_cost'].'" />
                        <input type="hidden" name="quantity_1" 				value="1" />
                                            
                        <input type="hidden" name="max_lay_length_1" 		value="'.MODULE_PAYMENT_ELAYAWAY_MAXIMUM_LENGTH.'" />
                        <input type="hidden" name="min_lay_length_1" 		value="'.MODULE_PAYMENT_ELAYAWAY_MINIMUM_LENGTH.'" />
                    </form>
                </body>
            </html>
            ';
                                              
                                              echo $html;
            $cart->reset(true);
            tep_session_unregister('sendto');
            tep_session_unregister('billto');
            tep_session_unregister('shipping');
            tep_session_unregister('payment');
            tep_session_unregister('comments');
            die();
            return false;
        }
        
        function get_error() {
            return false;
        }
        
        function check() {
            if (!isset($this->_check)) {
                $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ELAYAWAY_STATUS'");
                $this->_check = tep_db_num_rows($check_query);
            }
            return $this->_check;
        }
        
    function install() {
        $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Check eLayaway' limit 1");
        if(tep_db_num_rows($check_query) < 1) {
            $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
            $status = tep_db_fetch_array($status_query);
            
            $status_id = $status['status_id']+1;
            
            $languages = tep_get_languages();
            
            foreach ($languages as $lang) {
                tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $lang['id'] . "', 'Check eLayaway')");
            }
            
            $flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
            if (tep_db_num_rows($flags_query) == 1) {
                tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 0 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
            }
        } else {
            $check = tep_db_fetch_array($check_query);
            
            $status_id = $check['orders_status_id'];
        }
                                           
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable eLayaway Layaway Payment Module', 'MODULE_PAYMENT_ELAYAWAY_STATUS', 'True', 'Do you want to accept eLayaway payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_ELAYAWAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_ELAYAWAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_ELAYAWAY_ORDER_STATUS', '".$status_id."', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
                                           
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Merchant Display Name', 'MODULE_PAYMENT_ELAYAWAY_MERCHANT_DISPLAY_NAME', '', 'The name of the merchant that should be displayed during the checkout process.', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values('Merchant ID', 'MODULE_PAYMENT_ELAYAWAY_MERCHANT_ID', '', 'The merchant ID given during the creating of the merchant account on eLayaway.', '6', '0', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values('Minimum Layaway Length', 'MODULE_PAYMENT_ELAYAWAY_MINIMUM_LENGTH', '2', 'The minimum layaway length. eLayaway requires that the minimum layaway length is 2.', '6', '0', 'tep_draw_pull_down_menu(\'configuration[MODULE_PAYMENT_ELAYAWAY_MINIMUM_LENGTH]\', array(\'2\', \'3\', \'4\', \'5\', \'6\', \'7\', \'8\', \'9\', array(\'id\' => \'10\', \'text\' => \'10\'), array(\'id\' => \'11\', \'text\' => \'11\'), array(\'id\' => \'12\', \'text\' => \'12\')), ',  now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values('Maximum Layaway Length', 'MODULE_PAYMENT_ELAYAWAY_MAXIMUM_LENGTH', '12', 'The maximum layaway length. eLayaway requires that the maximum layaway length is 12.', '6', '0', 'tep_draw_pull_down_menu(\'configuration[MODULE_PAYMENT_ELAYAWAY_MAXIMUM_LENGTH]\', array(\'2\', \'3\', \'4\', \'5\', \'6\', \'7\', \'8\', \'9\', array(\'id\' => \'10\', \'text\' => \'10\'), array(\'id\' => \'11\', \'text\' => \'11\'), array(\'id\' => \'12\', \'text\' => \'12\')), ', now())");
    }

    
        function remove() {
            tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        }
        
        function keys() {
            return array('MODULE_PAYMENT_ELAYAWAY_STATUS', 'MODULE_PAYMENT_ELAYAWAY_ZONE', 'MODULE_PAYMENT_ELAYAWAY_ORDER_STATUS', 'MODULE_PAYMENT_ELAYAWAY_SORT_ORDER', 'MODULE_PAYMENT_ELAYAWAY_MERCHANT_DISPLAY_NAME', 'MODULE_PAYMENT_ELAYAWAY_MERCHANT_ID', 'MODULE_PAYMENT_ELAYAWAY_MINIMUM_LENGTH', 'MODULE_PAYMENT_ELAYAWAY_MAXIMUM_LENGTH');
        }
}
?>
